(*Generated by Lem from abis/aarch64/abi_aarch64_section_header_table.lem.*)
(** [abi_aarch64_section_header_table], AARCH64 ABI specific definitions related
  * to the section header table.
  *)

open Lem_basic_classes
open Lem_num

(** AARCH64 specific section types *)

(** Contains build attributes.  What these are is not specified, and compilers
  * are free to insert their own proprietary information in this section.  See
  * Section 4.3.
  *)
let sht_aarch64_attributes : Nat_big_num.num=  (Nat_big_num.add ( Nat_big_num.mul( (Nat_big_num.of_int 939524097))( (Nat_big_num.of_int 2)))( (Nat_big_num.of_int 1))) (* 0x70000003 *)

(** [string_of_aarch64_section_type m] produces a string based representation of
  * AARCH64 section type [m].
  *)
(*val string_of_aarch64_section_type : natural -> string*)
let string_of_aarch64_section_type m:string=
   (if Nat_big_num.equal m sht_aarch64_attributes then
    ".ARM.attributes"
  else
    "Unrecognised section type")
